;##################################################################
; SymbolList
;##################################################################

#include SymbolList.h

IDD_DLG1			equ		1000

DATA SECTION
	hInstance			HANDLE 		?
	hDlg				HANDLE		?

	hSymbolListview	HANDLE		?
	hProcessFile		HANDLE		?

	ClassName			DB			"DialogClass",0

	szFilterStr			CHAR		"Executable files (*.exe)",0,"*.exe",0,0
	szDefExt			CHAR		"EXE",0
	szOpenCaption		CHAR		"Select exe file",0
	ofrFilePath			CHAR		MAX_PATH DUP (?)

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls
	invoke WinMain,[hInstance],NULL,NULL,SW_SHOW
	invoke ExitProcess,0

WinMain FRAME hInst,hPrevInstance,lpCmdLine,nCmdShow
	LOCAL	wc				:WNDCLASSEX
	LOCAL	msg				:MSG
	LOCAL	hdc				:%HANDLE

	; Define our main window class and register it
	mov		D[wc.cbSize], SIZEOF WNDCLASSEX
	mov		D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov		D[wc.lpfnWndProc], OFFSET DlgProc
	mov		D[wc.cbClsExtra], NULL
	mov		D[wc.cbWndExtra], DLGWINDOWEXTRA
	mov		eax, [hInstance]
	mov		D[wc.hInstance], eax
	mov		D[wc.hbrBackground], COLOR_BTNFACE + 1
	mov		D[wc.lpszMenuName], NULL
	mov		D[wc.lpszClassName], OFFSET ClassName
	invoke	LoadIcon, NULL, IDI_APPLICATION
	mov		D[wc.hIcon], eax
	mov		D[wc.hIconSm], eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov		D[wc.hCursor], eax

	invoke	RegisterClassEx, offset wc
	or eax,eax
	jnz >
		; If we were unable to register the class shut down
		invoke	ExitProcess, -1
	:

	invoke	CreateDialogParam, [hInstance],IDD_DLG1, NULL, NULL, NULL
	or eax,eax
	jnz >
		; If we were unable to create the dialog shut down
		invoke	ExitProcess, -1
	:
	mov [hDlg],eax

	invoke GetDlgItem,[hDlg],1002
	mov [hSymbolListview],eax
	invoke SetupSymbolListView,eax

	invoke ShowWindow,[hDlg],[nCmdShow]

	:
		invoke GetMessage, offset msg,NULL,0,0
		or eax,eax
		jz >
			invoke IsDialogMessage, [hDlg], offset msg
			or eax,eax
			jnz <
				invoke TranslateMessage, offset msg
				invoke DispatchMessage, offset msg
				jmp <
	:

	mov eax,[msg.wParam]

	ret
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL sui		:STARTUPINFO
	LOCAL pi		:PROCESS_INFORMATION
	LOCAL dbe		:DEBUG_EVENT

	cmp D[uMsg],WM_CREATE
	jne >.WM_COMMAND
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WM_DESTROY
	movzx edx,W[wParam]
	cmp edx,1003
	jne >>.EXIT
		invoke GetFile,[hInstance],[hwnd]
		test eax,eax
		jz >>.EXIT

		invoke RtlZeroMemory,offset pi,SIZEOF PROCESS_INFORMATION
		invoke RtlZeroMemory,offset sui,SIZEOF STARTUPINFO

		invoke CreateProcess,NULL,OFFSET ofrFilePath,NULL,NULL,\
					TRUE,DEBUG_ONLY_THIS_PROCESS,NULL,NULL,OFFSET sui,OFFSET pi

		.WAIT_FOR_EVENT
		invoke WaitForDebugEvent,offset dbe,50000

		.CREATE_PROCESS_DEBUG_EVENT
		cmp D[dbe.dwDebugEventCode],CREATE_PROCESS_DEBUG_EVENT
		jne >>
			invoke EnumerateSymbols,[dbe.u.CreateProcessInfo.hFile],[dbe.u.CreateProcessInfo.hProcess],[dbe.u.CreateProcessInfo.lpBaseOfImage]
		:
		invoke TerminateProcess,[pi.hProcess],0
		invoke CloseHandle,[pi.hProcess]
		invoke CloseHandle,[pi.hThread]
		jmp >.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >.DEFPROC
		invoke PostQuitMessage,0

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
		ret

	.EXIT

	xor eax,eax
	ret

ENDF

EnumerateSymbols FRAME hFile, hProcess, ImageBase
	LOCAL fsh:%DWORD32
	LOCAL fsl:%DWORD32
	LOCAL ProcessPath[2048]:%CHAR
	LOCAL ihmod64:IMAGEHLP_MODULE64

	mov D[ProcessPath],0

	invoke SetLastError,0
	invoke GetProcessImageFileName ,[hProcess],offset ProcessPath,MAX_PATH

	invoke GetFileSize,[hFile],offset fsh
	mov [fsl],eax

	invoke SymInitialize,[hProcess], offset ProcessPath, FALSE

	invoke SymLoadModuleEx,[hProcess],[hFile],offset ProcessPath,NULL,[ImageBase],0,[fsl],0,0

	push eax,edx

	mov D[ihmod64.SizeOfStruct],SIZEOF IMAGEHLP_MODULE64
	invoke SymGetModuleInfo64,[hProcess],[ImageBase],0,offset ihmod64

	pop edx,eax
	cmp D[ihmod64.SymType],SymNone
	je >>.NOSYMBOLS

	// Note the the base address is 64 bit pushed as 2 dwords (eax,edx)
	invoke SymEnumSymbols,[hProcess],eax,edx,"*",offset SymEnumSymbolsProc, [hProcess]

	invoke SymUnloadModule64,[hProcess],[ImageBase],0

	invoke SymCleanup,[hProcess]
	
	
	cmp D[ihmod64.NumSyms],0
	je >
	invoke SetDlgItemInt,[hDlg],1005,[ihmod64.NumSyms]
	jmp >.EXIT
	:
	invoke SendMessage,[hSymbolListview],LVM_GETITEMCOUNT,0,0
	invoke SetDlgItemInt,[hDlg],1005,eax
	.EXIT
	xor eax,eax
	RET

	.NOSYMBOLS
	xor eax,eax
	dec eax
	ret
ENDF

SymEnumSymbolsProc FRAME pSymInfo, SymbolSize, UserContext
	uses edi,ebx
	LOCAL LVItem	:LVITEM
	LOCAL ItemID	:D
	LOCAL AddrBuffer[64]:%CHAR

	invoke SendMessage,[hSymbolListview],LVM_GETITEMCOUNT,0,0
	mov [ItemID],eax

	mov edi,[pSymInfo]
	add edi,4

	// For embedded COFF symbols [edi+SYMBOL_INFO.Tag] = SymTagPublicSymbol

	lea eax,edi+SYMBOL_INFO.Name
	mov cl,[eax]
	cmp cl,"?"
	je >>.CONTINUE
	mov [LVItem.pszText],eax
	mov D[LVItem.mask], LVIF_TEXT + LVIF_PARAM
	mov eax,[edi+SYMBOL_INFO.Address]
	mov [LVItem.lParam],eax
	mov D[LVItem.iSubItem],0
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	invoke SendMessage,[hSymbolListview],LVM_INSERTITEM,0,OFFSET LVItem
	mov [LVItem.iItem],eax

	invoke wsprintf,offset AddrBuffer,"0x%08X",[edi+SYMBOL_INFO.Address]
	add esp,12
	lea eax,AddrBuffer
	mov [LVItem.pszText],eax
	mov D[LVItem.iSubItem],1
	mov D[LVItem.mask],LVIF_TEXT
	invoke SendMessage,[hSymbolListview],LVM_SETITEM,0,OFFSET LVItem

	push ADDR "0"
	pop [LVItem.pszText]
	mov D[LVItem.iSubItem],2
	mov D[LVItem.mask],LVIF_TEXT
	invoke SendMessage,[hSymbolListview],LVM_SETITEM,0,OFFSET LVItem

	.CONTINUE
	mov eax,TRUE
	RET
ENDF

GetFile FRAME hInstance, hDlg
	LOCAL ofn				:OPENFILENAME
	LOCAL ofrFileTitle[64]	:%CHAR

	mov D[ofn.lStructSize],SIZEOF OPENFILENAME
	mov eax,[hDlg]
	mov [ofn.hwndOwner],eax
	mov eax,[hInstance]
	mov D[ofn.hInstance],NULL
	mov [ofn.lpstrFilter],OFFSET szFilterStr
	mov D[ofn.lpstrCustomFilter],NULL
	mov D[ofn.nMaxCustFilter],NULL
	mov D[ofn.nFilterIndex],1
	mov eax,OFFSET ofrFilePath
	mov D[eax],0
	mov [ofn.lpstrFile],eax
	mov D[ofn.nMaxFile],MAX_PATH
	mov D[ofn.lpstrFileTitle],NULL
	mov D[ofn.nMaxFileTitle],NULL
	mov D[ofn.lpstrInitialDir],NULL
	mov [ofn.lpstrTitle],OFFSET szOpenCaption
	mov D[ofn.Flags],OFN_FILEMUSTEXIST + OFN_NONETWORKBUTTON + OFN_EXPLORER + OFN_HIDEREADONLY
	mov D[ofn.lpfnHook],NULL
	mov D[ofn.lpTemplateName],NULL
	mov [ofn.lpstrDefExt],OFFSET szDefExt
	mov D[ofn.lCustData],NULL

	invoke GetOpenFileName,ADDR ofn
	ret
ENDF

SetupSymbolListView FRAME hLv
	uses edi,esi
	LOCAL LVColumn		:LVCOLUMN

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],200
	push ADDR "Symbol name"
	pop [LVColumn.pszText]
	mov D[LVColumn.cchTextMax],NULL
	invoke SendMessage,[hLv],LVM_INSERTCOLUMN,0,OFFSET LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	push ADDR "Symbol Address"
	pop [LVColumn.pszText]
	mov D[LVColumn.cchTextMax],NULL
	invoke SendMessage,[hLv],LVM_INSERTCOLUMN,1,OFFSET LVColumn

	invoke SendMessage,[hLv],LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES

	ret
ENDF
